#include "CorpSCADANetworksRMPVNodes.h"

CorpSCADANetworksRMPV0Worker::CorpSCADANetworksRMPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&CorpSCADANetworks);
}

CorpSCADANetworksRMPV0Worker::~CorpSCADANetworksRMPV0Worker() {
  delete [] TheModelPtr;
}

double CorpSCADANetworksRMPV0Worker::Reward_Function(void) {

return CorpSCADANetworks->CorporateLAN_NetworkAccess->Mark();

return (0);



}

CorpSCADANetworksRMPV0::CorpSCADANetworksRMPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheCorpSCADANetworksADVISE);
  double startpts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  double stoppts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  Initialize("a_CorporateLAN_NetworkAccess",(RewardType)0,51, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("CorporateLAN_NetworkAccess","CorpSCADANetworks");
}

CorpSCADANetworksRMPV0::~CorpSCADANetworksRMPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void CorpSCADANetworksRMPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new CorpSCADANetworksRMPV0Worker;
}
CorpSCADANetworksRMPV1Worker::CorpSCADANetworksRMPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&CorpSCADANetworks);
}

CorpSCADANetworksRMPV1Worker::~CorpSCADANetworksRMPV1Worker() {
  delete [] TheModelPtr;
}

double CorpSCADANetworksRMPV1Worker::Reward_Function(void) {

return CorpSCADANetworks->SCADALAN_NetworkAccess->Mark();

return (0);



}

CorpSCADANetworksRMPV1::CorpSCADANetworksRMPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheCorpSCADANetworksADVISE);
  double startpts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  double stoppts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  Initialize("a_SCADALAN_NetworkAccess",(RewardType)0,51, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("SCADALAN_NetworkAccess","CorpSCADANetworks");
}

CorpSCADANetworksRMPV1::~CorpSCADANetworksRMPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void CorpSCADANetworksRMPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new CorpSCADANetworksRMPV1Worker;
}
CorpSCADANetworksRMPV2Worker::CorpSCADANetworksRMPV2Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&CorpSCADANetworks);
}

CorpSCADANetworksRMPV2Worker::~CorpSCADANetworksRMPV2Worker() {
  delete [] TheModelPtr;
}

double CorpSCADANetworksRMPV2Worker::Reward_Function(void) {

return CorpSCADANetworks->MalwareonSCADANet->Mark();

return (0);



}

CorpSCADANetworksRMPV2::CorpSCADANetworksRMPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheCorpSCADANetworksADVISE);
  double startpts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  double stoppts[51]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0, 360.0, 370.0, 380.0, 390.0, 400.0, 410.0, 420.0, 430.0, 440.0, 450.0, 460.0, 470.0, 480.0, 490.0, 500.0};
  Initialize("g_MalwareOnSCADANet",(RewardType)0,51, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("MalwareonSCADANet","CorpSCADANetworks");
}

CorpSCADANetworksRMPV2::~CorpSCADANetworksRMPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void CorpSCADANetworksRMPV2::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new CorpSCADANetworksRMPV2Worker;
}
